pipeline {
    agent { 
        label {
            label 'jenkins-slave-ros-noetic-basic'
            customWorkspace '/home/jenkins/vdemo-startup'
        } 
    }
    options {
        timeout(time: 1, unit: 'HOURS')
        timestamps()
        buildDiscarder(logRotator(numToKeepStr:'5',daysToKeepStr: '90',artifactDaysToKeepStr: '90',artifactNumToKeepStr: '10'))
    }
    triggers {
        pollSCM('H/5 * * * *')
    }    
    stages {
        stage('Copy Dependencies') {
            steps {                
                copyArtifacts(projectName: 'MAS ROS-Utils/mas%2Fprojects%2Fros-utils%2Fvdemo/master', flatten: true, selector: lastSuccessful(), target: "/home/jenkins/");
                unzip zipFile: '/home/jenkins/vdemo.zip', dir: '/vol/distribution'
            }
        }
        stage('build') {
            steps {
                sh '''#!/bin/bash -l
                    source /opt/ros/noetic/setup.bash;

                    # Set environment variables
                    export PKG_CONFIG_PATH="/vol/distribution/lib/pkgconfig:${PKG_CONFIG_PATH}";
                    export CFLAGS="-march=core2 -O2     ${CFLAGS}";
                    export CXXFLAGS="-march=core2 -O2     ${CXXFLAGS}";
                    export CPPFLAGS="-march=core2 -O2     ${CPPFLAGS}";
                    export LDFLAGS="-L/vol/distribution/lib -Wl,-rpath,/vol/distribution/lib ${LDFLAGS}";

                    VDEMO_DIR="$(find "/vol/distribution/" -type f \\( -name "vdemoConfig.cmake" -o -name "vdemo-config.cmake" \\) -exec dirname {} \\; -quit)";

                    # Configure
                    cmake  \
                        -D vdemo_DIR="${VDEMO_DIR}" \
                        -D CMAKE_CXX_FLAGS="${CXXFLAGS}" \
                        -D CMAKE_C_FLAGS="${CFLAGS}" \
                        -D CMAKE_SKIP_BUILD_RPATH=FALSE \
                        -D CMAKE_BUILD_WITH_INSTALL_RPATH=FALSE \
                        -D CMAKE_INSTALL_RPATH="/vol/distribution/lib" \
                        -D CMAKE_INSTALL_PREFIX="/vol/distribution" \
                        -D CMAKE_BUILD_TYPE=RelWithDebInfo;

                    # Build
                    make -j1;

                    # Install
                    make -j1 install;
                '''
            }
        }
        stage('release') {
            steps {
                zip archive: true, dir: "/vol/distribution", glob: '', zipFile: "vdemo-startup.zip"
            }
        }
    }
}